﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using JobTracking.Models;

namespace JobTracking.Controllers
{
    [Authorize]
    public class ClientController : Controller
    {
        private JobTrackerEntities db = new JobTrackerEntities();

        //
        // GET: /Client/

        public ViewResult Index()
        {
            return View(db.Clients.ToList());
        }

        //
        // GET: /Client/Details/5

        public ViewResult Details(int id)
        {
            Client client = db.Clients.Single(c => c.ClientID == id);
            return View(client);
        }

        //
        // GET: /Client/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Client/Create

        [HttpPost]
        public ActionResult Create(Client client)
        {
            if (ModelState.IsValid)
            {
                db.Clients.AddObject(client);
                db.SaveChanges();
                return RedirectToAction("Index");  
            }

            return View(client);
        }
        
        //
        // GET: /Client/Edit/5
 
        public ActionResult Edit(int id)
        {
            Client client = db.Clients.Single(c => c.ClientID == id);
            return View(client);
        }

        //
        // POST: /Client/Edit/5

        [HttpPost]
        public ActionResult Edit(Client client)
        {
            if (ModelState.IsValid)
            {
                db.Clients.Attach(client);
                db.ObjectStateManager.ChangeObjectState(client, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(client);
        }

        //
        // GET: /Client/Delete/5
 
        public ActionResult Delete(int id)
        {
            Client client = db.Clients.Single(c => c.ClientID == id);
            return View(client);
        }

        //
        // POST: /Client/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {            
            Client client = db.Clients.Single(c => c.ClientID == id);
            db.Clients.DeleteObject(client);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}