﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using JobTracking.Models;

namespace JobTracking.Controllers
{ 
    public class JobWorksLogController : Controller
    {
        private JobTrackerEntities db = new JobTrackerEntities();

        //
        // GET: /JobWorksLog/

        public ViewResult Index()
        {
            var jobworkslogs = db.JobWorksLogs.Include("aspnet_Users").Include("Job").Where(s => s.JobID == CurrentJob.JobID); ;
            return View(jobworkslogs.ToList());
        }

        //
        // GET: /JobWorksLog/Details/5

        public ViewResult Details(int id)
        {
            JobWorksLog jobworkslog = db.JobWorksLogs.Single(j => j.JobWorkLogID == id);
            return View(jobworkslog);
        }

        //
        // GET: /JobWorksLog/Create

        public ActionResult Create()
        {
           // ViewBag.StartTime = DateTime.Now;
           // ViewBag.EndTime = DateTime.Now;
            ViewBag.UserID = new SelectList(db.aspnet_Users, "UserId", "UserName");
            ViewBag.JobID = new SelectList(db.Jobs, "JobID", "JobID");
            
            return View();
        } 

        //
        // POST: /JobWorksLog/Create

        [HttpPost]
        public ActionResult Create(JobWorksLog jobworkslog)
        {
            if (ModelState.IsValid)
            {
              //  jobworkslog.StartTime = DateTime.Now;
              //  jobworkslog.EndTime = DateTime.Now;
                jobworkslog.UserID = CurrentUser.UserID;
                jobworkslog.JobID = CurrentJob.JobID;
                jobworkslog.CreationDateTime = DateTime.Now;
                db.JobWorksLogs.AddObject(jobworkslog);
                db.SaveChanges();
                return RedirectToAction("Index");  
            }

            ViewBag.UserID = new SelectList(db.aspnet_Users, "UserId", "UserName", jobworkslog.UserID);
            ViewBag.JobID = new SelectList(db.Jobs, "JobID", "JobID", jobworkslog.JobID);
            return View(jobworkslog);
        }
        
        //
        // GET: /JobWorksLog/Edit/5
 
        public ActionResult Edit(int id)
        {
            JobWorksLog jobworkslog = db.JobWorksLogs.Include("aspnet_Users").Include("Job").Single(j => j.JobWorkLogID == id);
            ViewBag.UserID = new SelectList(db.aspnet_Users, "UserId", "UserName", jobworkslog.UserID);
            ViewBag.JobID = new SelectList(db.Jobs, "JobID", "JobID", jobworkslog.JobID);
            return View(jobworkslog);
        }

        //
        // POST: /JobWorksLog/Edit/5

        [HttpPost]
        public ActionResult Edit(JobWorksLog jobworkslog)
        {
            if (ModelState.IsValid)
            {
               // jobworkslog.StartTime = DateTime.Now;
              //  jobworkslog.EndTime = DateTime.Now;
                jobworkslog.UserID = CurrentUser.UserID;
                jobworkslog.JobID = CurrentJob.JobID;
                jobworkslog.CreationDateTime = DateTime.Now;
                db.JobWorksLogs.Attach(jobworkslog);
                db.ObjectStateManager.ChangeObjectState(jobworkslog, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.UserID = new SelectList(db.aspnet_Users, "UserId", "UserName", jobworkslog.UserID);
            ViewBag.JobID = new SelectList(db.Jobs, "JobID", "JobID", jobworkslog.JobID);
            return View(jobworkslog);
        }

        //
        // GET: /JobWorksLog/Delete/5
 
        public ActionResult Delete(int id)
        {
            JobWorksLog jobworkslog = db.JobWorksLogs.Include("aspnet_Users").Include("Job").Single(j => j.JobWorkLogID == id);
            return View(jobworkslog);
        }

        //
        // POST: /JobWorksLog/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {            
            JobWorksLog jobworkslog = db.JobWorksLogs.Single(j => j.JobWorkLogID == id);
            db.JobWorksLogs.DeleteObject(jobworkslog);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}