﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using JobTracking.Models;

namespace JobTracking.Controllers
{
    [Authorize(Roles = "Administrator")]
    public class NoteTypeController : Controller
    {
        private JobTrackerEntities db = new JobTrackerEntities();

        //
        // GET: /NoteType/

        public ViewResult Index()
        {
            return View(db.NoteTypes.ToList());
        }

        //
        // GET: /NoteType/Details/5

        public ViewResult Details(int id)
        {
            NoteType notetype = db.NoteTypes.Single(n => n.NoteTypeID == id);
            return View(notetype);
        }

        //
        // GET: /NoteType/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /NoteType/Create

        [HttpPost]
        public ActionResult Create(NoteType notetype)
        {
            if (ModelState.IsValid)
            {
                db.NoteTypes.AddObject(notetype);
                db.SaveChanges();
                return RedirectToAction("Index");  
            }

            return View(notetype);
        }
        
        //
        // GET: /NoteType/Edit/5
 
        public ActionResult Edit(int id)
        {
            NoteType notetype = db.NoteTypes.Single(n => n.NoteTypeID == id);
            return View(notetype);
        }

        //
        // POST: /NoteType/Edit/5

        [HttpPost]
        public ActionResult Edit(NoteType notetype)
        {
            if (ModelState.IsValid)
            {
                db.NoteTypes.Attach(notetype);
                db.ObjectStateManager.ChangeObjectState(notetype, EntityState.Modified);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(notetype);
        }

        //
        // GET: /NoteType/Delete/5
 
        public ActionResult Delete(int id)
        {
            NoteType notetype = db.NoteTypes.Single(n => n.NoteTypeID == id);
            return View(notetype);
        }

        //
        // POST: /NoteType/Delete/5

        [HttpPost, ActionName("Delete")]
        public ActionResult DeleteConfirmed(int id)
        {            
            NoteType notetype = db.NoteTypes.Single(n => n.NoteTypeID == id);
            db.NoteTypes.DeleteObject(notetype);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}